
<template>
     <#ibizinclude>
    ./CONTROL.html.ftl
    </#ibizinclude>
</template>

<#ibizinclude>
../@MACRO/CONTROL/CONTROL_DEFAULT.vue.ftl
</#ibizinclude>

<#assign self_content>
        /**
        * 标题
        *
        * @type {string}
        * @memberof ${srfclassname('${ctrl.codeName}')}
        */
        @Prop() public title?: string;
        
        /**
        * 搜索行为
        *
        * @param {string}
        * @memberof ${srfclassname('${ctrl.codeName}')}
        */
        @Prop() public searchAction?:string;

        /**
        * searchKey 搜索关键字
        *
        * @type {string}
        * @memberof ${srfclassname('${ctrl.codeName}')}
        */
         public searchKey:string | undefined;

        /**
        * 分页大小
        *
        * @type {number}
        * @memberof ${srfclassname('${ctrl.codeName}')}
        */
        public pageSize:number = ${ctrl.getPagingSize()?c};
    
        /**
        * 总页数
        *
        * @type {number}
        * @memberof ${srfclassname('${ctrl.codeName}')}
        */
         public pageTotal:number = 0;
    
        /**
        * 当前页数
        *
        * @type {number}
        * @memberof ${srfclassname('${ctrl.codeName}')}
        */
         public pageNumber:any = 1;
    
        /**
        * 判断底部数据是否全部加载完成，若为真，则 bottomMethod 不会被再次触发
        *
        * @type {number}
        * @memberof ${srfclassname('${ctrl.codeName}')}
        */
         public allLoaded: boolean = false;

        /**
        * Api地址
        *
        * @type {string}
        * @memberof ${srfclassname('${ctrl.codeName}')}
        */
        public url: string = '${app.getPKGCodeName()?lower_case}/${de.getPSSystemModule().codeName?lower_case}/${de.codeName?lower_case}/${ctrl.codeName?lower_case}${srfclassname(ctrl.getControlType())?lower_case}/';

        /**
        * 列表数组
        *
        * @param {Array<any>}
        * @memberof ${srfclassname('${ctrl.codeName}')}
        */
        public items:Array<any> =[];

        /**
        * 下拉刷新
        *
        * @memberof ${srfclassname('${ctrl.codeName}')}
        */
        public loadTop() {
          this.pageNumber=1;
          this.load(Object.assign({query:this.searchKey},{page: { current: this.pageNumber, size: this.pageSize }}),'top');
        }

        /**
        * 上拉加载更多数据
        * 
        * @memberof ${srfclassname('${ctrl.codeName}')}
        */
        public loadBottom() {
          this.pageNumber++;
          this.load(Object.assign({query:this.searchKey},{page: { current: this.pageNumber, size: this.pageSize }}),'bottom');
        }

        /**
        * 多项数据加载
        *
        * @private
        * @param {*} [arg={}]
        * @memberof ${srfclassname('${ctrl.codeName}')}
        */
        private load(data:any,type:any):void {
              const post: Promise<any> = this.$http.post(this.url + this.searchAction, data);
                post.then((response: any) => {
                if (!response || response.status !== 200) {
                  this.$notify({ type: 'danger', message: '错误,' + response.info });
                }
                this.pageTotal = response.data.total;
                this.allLoaded = this.pageNumber>=this.pageTotal/this.pageSize?true:false;
                if(type=='top'){
                    this.items=[];
                    this.items = response.data.records;
                    let  loadmore:any = this.$refs.loadmore;
                    loadmore.onTopLoaded();
                }
              else if(type=='bottom'){
                    setTimeout(()=>{
                          for(let i=0;i<response.data.records.length;i++){
                          this.items.push(response.data.records[i]);
                      }
                        let  loadmore:any = this.$refs.loadmore;
                        loadmore.onBottomLoaded();
                      },2000)
                }else{
                  this.items=[];
                  this.items = response.data.records;
                }
              })
              .catch((response: any) => {
                if (response && response.status === 401) {
                  return;
                }
                if (!response || !response.status || !response.data) {
                  this.$notify({ type: 'danger', message: '错误,系统异常！' });
                  return;
                }
                const { data: _data } = response;
                console.error(_data.title + _data.message);
              });
        }

        /**
        * vue生命周期created
        *
        * @memberof ${srfclassname('${ctrl.codeName}')}
        */       
        created() {
          this.handleCreated();
        }

        /**
        * 执行created后的逻辑
        *
        * @memberof ${srfclassname('${ctrl.codeName}')}
        */    
        public handleCreated(){
          if (this.viewState) {
            this.viewState.subscribe(
                ({ tag, action, data }) => {
                    if (!Object.is(tag, this.name)) {
                        return;
                    }
                    if (Object.is(action, "load")) {
                    this.pageNumber = 1;
                    this.load(Object.assign(data, {page: { current: this.pageNumber, size: this.pageSize }}),"init");
                    }
                    if (Object.is(action, "search")) {
                        this.load(Object.assign(data, {page: { current: this.pageNumber, size: this.pageSize }}),"" );
                    }
                    if (Object.is(action, "quicksearch")) {
                        this.searchKey = data;
                        this.load( Object.assign( { query: data }, { page: { current: 1, size: this.pageSize*this.pageNumber }}),"init");
                    }
                }
            );
          }
        }

</#assign>

<#ibizinclude>
../@MACRO/CONTROL/CONTROL_CONTAINER.vue.ftl
</#ibizinclude>

<style lang="less">
     <#ibizinclude>
    ./CONTROL.less.ftl
    </#ibizinclude>
</style>