<template>
    <#ibizinclude>
    ./CONTROL.html.ftl
    </#ibizinclude>
</template>

<#ibizinclude>
../@MACRO/CONTROL/CONTROL_DEFAULT.vue.ftl
</#ibizinclude>

<#assign self_content>
  /**
     * Api地址
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    public url: string = '${app.getPKGCodeName()?lower_case}/${de.getPSSystemModule().codeName?lower_case}/${de.codeName?lower_case}/${ctrl.codeName?lower_case}${srfclassname(ctrl.getControlType())?lower_case}/';

    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    public getDatas(): any[] {
        return [];
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    public getData(): any {
        return null;
    }

    /**
     * 视图状态订阅对象
     *
     * @private
     * @type {Subject<{action: string, data: any}>}
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    private wizardState: Subject<ViewState> = new Subject();

    /**
     * 当前激活表单
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    <#if ctrl.getPSDEWizard()?? && ctrl.getPSDEWizard().getFirstPSDEWizardForm()??>
    <#assign firstForm = ctrl.getPSDEWizard().getFirstPSDEWizardForm()>
    public activeForm: string = '${ctrl.name}_form_${firstForm.getFormTag()}';
    <#else>
    public activeForm: string = '';
    </#if>

    /**
     * 向导表单参数
     *
     * @type {*}
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    public formParam: any = {};

    /**
     * 执行过的表单
     *
     * @private
     * @type {Array<string>}
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    public historyForms: Array<string> = [];

    /**
     * 步骤行为集合
     *
     * @type {*}
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    public stepActions: any = {};

    /**
     * 向导表单集合
     *
     * @type {Array<any>}
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    public wizardForms: Array<any> = [];

    /**
     * 当前状态
     *
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    public curState = '';

    /**
     * 是否选中Obj
     *
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    public isAgreeObj:any ={
        <#if ctrl.getPSControls()??>
        <#list ctrl.getPSControls() as form>
        <#if form.getPSDEWizardForm().getConfirmMsg()??  && form.getPSDEWizardForm().getConfirmMsg() !="">
        '${ctrl.name}_form_${form.getPSDEWizardForm().getFormTag()}_msg':false,
        </#if>
        <#if form.getPSDEWizardForm().getConfirmMsg2()??  && form.getPSDEWizardForm().getConfirmMsg2() !="">
        '${ctrl.name}_form_${form.getPSDEWizardForm().getFormTag()}_msg2':false,
        </#if>
        </#list>
        </#if>
    };

    public created(){
        this.handleCreated();
    }

    /**
     * 执行created后的逻辑
     *
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    public handleCreated(){
        this.regFormActions();
        if(this.activeForm) {
            this.historyForms.push(this.activeForm);
        }
        if (this.viewState) {
            this.viewState.subscribe(({ tag, action, data }) => {
                if (Object.is(tag, this.name)) {
                    if (Object.is('load', action)) {
                        this.initAction(data);
                    }
                }
            });
        }
    }

    /**
     * 注册表单步骤行为
     *
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    public regFormActions() {
        <#if ctrl.getPSDEWizard()?? && ctrl.getPSDEWizard().getPSDEWizardForms()??>
        <#list ctrl.getPSDEWizard().getPSDEWizardForms() as form>
        this.regFormAction('${ctrl.name}_form_${form.getFormTag()}', [<#if form.getStepActions()??><#list form.getStepActions() as action><#if action_index gt 0>,</#if>'${action}'</#list></#if>]);
        </#list>
        </#if>
    }

    /**
     * 注册表单步骤行为
     *
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    public regFormAction(name: string, actions: Array<string>) {
        this.stepActions[name] = actions;
        this.wizardForms.push(name);
    }

    /**
     * 初始化行为
     *
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    public initAction(opt: any = {}) {
        <#if ctrl.getPSDEWizard()?? && ctrl.getPSDEWizard().getInitPSDEAction()??>
        <#assign action = ctrl.getPSDEWizard().getInitPSDEAction()>
        const arg: any = { ...opt };
        this.$http.post(this.url + 'init', arg).then((response: any) => {
            if (response) {
                const data = response.data;
                this.formParam = { srfkey: data.srfkey };
                this.$emit('init',data);
                this.formLoad();
            }
        }).catch((error: any) => {
              this.$notify({ type: 'danger', message: '错误'+error.info });
        });
        </#if>
    }

    /**
     * 表单加载
     *
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    public formLoad() {
        if(this.activeForm) {
            this.wizardState.next({ tag: this.activeForm, action: 'load', data: this.formParam });
        }
    }

    /**
     * 完成行为
     *
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    public finishAction() {
        <#if ctrl.getPSDEWizard()?? && ctrl.getPSDEWizard().getFinishPSDEAction()??>
        <#assign action = ctrl.getPSDEWizard().getFinishPSDEAction()>
        let arg: any = {};
        Object.assign(arg, this.formParam);
        this.$http.post(this.url + 'finish', arg).then((response: any) => {
            if (response) {
                const data = response;
                this.$emit('finish',data);
            }
        }).catch((error: any) => {
              this.$notify({ type: 'danger', message: '错误'+error.info });
        });
        </#if>
    }

    /**
     * 向导表单加载完成
     *
     * @param {*} args
     * @param {string} name
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    public ${ctrl.name}_formload(args: any, name: string, $event2?: any) {
        if(args) {
            Object.assign(this.formParam, args);
        }
    }

    /**
     * 向导表单保存完成
     *
     * @param {*} args
     * @param {string} name
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    public ${ctrl.name}_formsave(args: any, name: string, $event2?: any) {
        Object.assign(this.formParam, args);
        if(Object.is(this.curState, 'NEXT')) {
            this.historyForms.push(name);
            if(args.srfnextform) {
                this.activeForm = '${ctrl.name}_form_' + args.srfnextform;
                setTimeout(() => {
                    this.formLoad();
                }, 1);
            } else if (this.getNextForm()) {
                this.activeForm = this.getNextForm();
                setTimeout(() => {
                    this.formLoad();
                }, 1);
            } else {
                this.finishAction();
            }
        }
        if(Object.is(this.curState, 'FINISH')) {
            this.finishAction();
        }
    }

    /**
     * 获取下一步向导表单
     *
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    public getNextForm() {
        let index = this.wizardForms.indexOf(this.activeForm);
        if(index >= 0) {
            if(this.wizardForms[index + 1]) {
                return this.wizardForms[index + 1];
            }
        }
        return undefined;
    }


    /**
     * 上一步
     *
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    public onClickPrev() {
        const length = this.historyForms.length;
        if(length > 1) {
            this.curState = 'PREV';
            this.activeForm = this.historyForms[length - 1];
            setTimeout(() => {
                this.formLoad();
            }, 1);
            this.historyForms.splice(length - 1, 1);
        }
    }

    /**
     * 下一步
     *
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    public onClickNext() {
        if(this.activeForm) {
            let currentCheckBox =[];
            if(Object.keys(this.isAgreeObj).length >0){
                currentCheckBox =Object.keys(this.isAgreeObj).filter((item:any) =>{
                    return item.startsWith(this.activeForm) && this.isAgreeObj[item] == false;
                })
            }
            if(currentCheckBox.length >0){
                this.$notify({ type: 'primary', message: '需先同意确认信息!'});
            }else{
                this.curState = 'NEXT';
                this.wizardState.next({ tag: this.activeForm, action: 'save', data: Object.assign(this.formParam,{iscancelnotice:true}) });
            }
        }
    }

    /**
     * 完成
     *
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    public onClickFinish() {
        if(this.activeForm) {
            let currentCheckBox =[];
            if(Object.keys(this.isAgreeObj).length >0){
                currentCheckBox =Object.keys(this.isAgreeObj).filter((item:any) =>{
                    return item.startsWith(this.activeForm) && this.isAgreeObj[item] == false;
                })
            }
             if(currentCheckBox.length >0){
                 this.$notify({ type: 'primary', message: '提示：需先同意确认信息!'});
            }else{
                this.curState = 'FINISH';
                this.wizardState.next({ tag: this.activeForm, action: 'save', data: Object.assign(this.formParam,{iscancelnotice:true}) });
            }
        }
    }

    /**
     * 是否显示
     *
     * @param {string} type
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    public isHidden(type: string) {
        const actions: Array<string> = this.stepActions[this.activeForm]
        if(actions && actions.indexOf(type) != -1) {
            return true;
        }
        return false;
    }
</#assign>

<#ibizinclude>
../@MACRO/CONTROL/CONTROL_CONTAINER.vue.ftl
</#ibizinclude>

<style lang="less">
    <#ibizinclude>
    ./CONTROL.less.ftl
    </#ibizinclude>
</style>