<template>
    <#ibizinclude>
    ./CONTROL.html.ftl
    </#ibizinclude>
</template>


<#assign self_components>
<#if view.hasPSControl('form')>
    <#assign form = view.getPSControl('form')>
    view_${form.getName()}, 
</#if>
</#assign>


<#ibizinclude>
../@MACRO/CONTROL/CONTROL_DEFAULT.vue.ftl
</#ibizinclude>

<#assign self_header>
import { Subject } from 'rxjs';
import '@/assets/interface/viewState';
    <#if ctrl.getPSControls?? && ctrl.getPSControls()??>
        <#list ctrl.getPSControls() as subctrl>
            <#if subctrl.getControlType() != 'TOOLBAR' && subctrl.getControlType() != 'CONTEXTMENU'>
                <#if subctrl.getPSDataEntity?? && subctrl.getPSDataEntity()??>
                import view_${subctrl.getName()} from '@/widget/${srffilepath2(subctrl.getPSDataEntity().getCodeName())}/${srffilepath2(subctrl.getCodeName())}-${subctrl.getControlType()?lower_case}/${srffilepath2(subctrl.getCodeName())}-${subctrl.getControlType()?lower_case}.vue';
                <#else>
                import view_${subctrl.getName()} from '@/widget/app/${srffilepath2(subctrl.getCodeName())}-${subctrl.getControlType()?lower_case}/${srffilepath2(subctrl.getCodeName())}-${subctrl.getControlType()?lower_case}.vue';
                </#if>
            </#if>
        </#list>
    </#if>

    <#if view.hasPSControl('form')>
        <#assign form = view.getPSControl('form')>
        <#if form.getPSDataEntity?? && form.getPSDataEntity()??>
        import view_${form.getName()} from '@/widget/${srffilepath2(form.getPSDataEntity().getCodeName())}/${srffilepath2(form.getCodeName())}-${form.getControlType()?lower_case}/${srffilepath2(form.getCodeName())}-${form.getControlType()?lower_case}.vue';
        <#else>
        import view_${form.getName()} from '@/widget/app/${srffilepath2(form.getCodeName())}-${form.getControlType()?lower_case}/${srffilepath2(form.getCodeName())}-${form.getControlType()?lower_case}.vue';
        </#if>
    </#if>

</#assign>





<#assign self_content>
    /**
    * 父页面传递来得srfkey
    *
    * @type {string}
    * @memberof ${srfclassname('${ctrl.name}')}
    */
    public parentSrfkey?: string;

    /**
    * 当前显示分页
    *
    * @type String
    * @memberof ${srfclassname('${view.name}')}
    */
    @Prop({ default: 'default' })public activeName?:String;

     /**
     * 关系界面所需的关联数据
     *
     * @type {}
     * @memberof ${srfclassname('${ctrl.name}')}
     */   
    public parentData:any = {
        <#if ctrl.getPSDEDRTabPages?? && ctrl.getPSDEDRTabPages()??>
            <#list ctrl.getPSDEDRTabPages() as tabpage>
            <#assign dritem = tabpage.getPSDEDRDetail() />
            <#assign tabview = tabpage.getPSAppView() />
                <#if dritem.getDetailType?? && dritem.getDetailType() == 'DRITEM'>
        '${dritem.getName()}':${dritem.getPSDEDRItem().getParentDataJO()},
                </#if>
            </#list>
        </#if>
    };

    /**
    * 获取对应的ViewData
    *
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public getViewdata(dritemName:string) {
        return JSON.stringify({srfparentdata:Object.assign({srfparentkey:this.parentSrfkey},this.parentData[dritemName])});
    }


    /**
    * vue生命周期
    *
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public created(){
        this.handleCreated();
    }

    /**
    * created之后执行逻辑
    *
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public handleCreated(){
        this.viewState.subscribe(( {tag,action,data })=>{
            if (!Object.is(tag, this.name)) {
                return;
            }
            if (Object.is('load', action)) {
                this.parentSrfkey = data.srfkey;
            }
            if (Object.is('save', action)) {
        <#if ctrl.getPSDEDRTabPages?? && ctrl.getPSDEDRTabPages()??>
            <#list ctrl.getPSDEDRTabPages() as tabpage>
            <#assign dritem = tabpage.getPSDEDRDetail() />
                this.viewState.next({tag: '${dritem.name}', action: 'save', data: {}});
            </#list>
        </#if>

            }
        })
    }
</#assign>

<#ibizinclude>
../@MACRO/CONTROL/CONTROL_CONTAINER.vue.ftl
</#ibizinclude>

<style lang="less">
    <#ibizinclude>
    ./CONTROL.less.ftl
    </#ibizinclude>
</style>