<template>
    <#ibizinclude>
    ./CONTROL.html.ftl
    </#ibizinclude>
</template>

<#ibizinclude>
../@MACRO/CONTROL/CONTROL_DEFAULT.vue.ftl
</#ibizinclude>

<#assign self_header>
import { Subject } from 'rxjs';
import '@/assets/interface/viewState';
<#if ctrl.getPSControls?? && ctrl.getPSControls()??>

<#list ctrl.getPSControls() as subctrl>
<#if subctrl.getControlType() != 'TOOLBAR' && subctrl.getControlType() != 'CONTEXTMENU'>
    <#if subctrl.getPSDataEntity?? && subctrl.getPSDataEntity()??>
import view_${subctrl.getName()} from '@/widget/${srffilepath2(subctrl.getPSDataEntity().getCodeName())}/${srffilepath2(subctrl.getCodeName())}-${subctrl.getControlType()?lower_case}/${srffilepath2(subctrl.getCodeName())}-${subctrl.getControlType()?lower_case}.vue';
<#else>
import view_${subctrl.getName()} from '@/widget/app/${srffilepath2(subctrl.getCodeName())}-${subctrl.getControlType()?lower_case}/${srffilepath2(subctrl.getCodeName())}-${subctrl.getControlType()?lower_case}.vue';
</#if>
</#if>
</#list>
</#if>
import echarts from 'echarts';
</#assign>




<#assign self_content>

    /**
     * 当前图表类型
     *
     * @type {}
     * @memberof ${srfclassname('${ctrl.name}')}
     */   
    public chartType:String = "<#if ctrl.getPSDEChartSerieses()??><#assign dechartSertieses = ctrl.getPSDEChartSerieses()><#list dechartSertieses as singleSertieses><#if singleSertieses_index = 0>${singleSertieses.getSeriesType()}</#if></#list></#if>";
 
     /**
     * 初始化图表所需参数
     *
     * @type {}
     * @memberof ${srfclassname('${ctrl.name}')}
     */   
    public $chartOption:any = {};

    /**
     * Api地址
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public url: string = '${app.getPKGCodeName()?lower_case}/${de.getPSSystemModule().codeName?lower_case}/${de.codeName?lower_case}/${ctrl.codeName?lower_case}${srfclassname(ctrl.getControlType())?lower_case}/';

    /**
    * Vue声明周期(组件初始化完毕)
    *
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public created() {
         this.handleCreated();     
    }

    /**
    * 执行created后的逻辑
    *
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public handleCreated(){
        if (this.viewState) {
            this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(tag, this.name)) {
                    return;
                }
                if (Object.is('load', action)) {
                    this.load(data);
                }
                if(Object.is('quicksearch', action)){
                    this.load({query:data});
                }
                if(Object.is('search', action)){
                    this.load(data);
                }
            });
        }  
    }

    /**
     * 获取图表基础配置数据
     * 
     * @returns {*} 
     * @memberof ${srfclassname('${ctrl.name}')}Service
     */
    public getChartConfig(): any {
        <#assign title=ctrl.getPSDEChartTitle()>
        <#assign xaxislist=ctrl.getPSDEChartAxesesByPos('x')>
        <#assign yaxislist=ctrl.getPSDEChartAxesesByPos('y')>
        <#assign customCode=''>
        <#if ctrl.getPSSysPFPlugin()??>
        <#assign customCode= ctrl.getPSSysPFPlugin().getCode("CODE2",pf.getId(),pfstyle.getId(),view,ctrl,null)> 
        </#if>

        const opts = {
            title: { show: <#if title.isShowTitle()>true<#else>false</#if><#if title.getTitle()??>, text: '${title.getTitle()}'</#if><#if title.getSubTitle()??>, subtext: '${title.getSubTitle()}'</#if> },
            legend: {}<#if ctrl.getCoordinateSystem()??><#if ctrl.getCoordinateSystem()='XY'>, tooltip: { trigger: 'axis' },
            xAxis: [
            <#assign first = 1>
            <#list ctrl.getPSDEChartAxeses() as axes>
            <#if axes.getAxesType() == 'category'>
            <#if first==0>, </#if><#assign first = 0>{ aixstag: '${axes.getName()}', type: 'category', position: '${axes.getAxesPos()}'<#if axes.getCaption()??>, name: '${axes.getCaption()}'</#if><#if axes.getMaxValue()??>, max: ${axes.getMaxValue()?c}</#if><#if axes.getMinValue()??>, min: ${axes.getMinValue()?c}</#if> }
            </#if>
            </#list>
            ],
            yAxis: [
            <#assign first = 1>
            <#list ctrl.getPSDEChartAxeses() as axes>
            <#if axes.getAxesType() == 'numeric'>
            <#if first==0>, </#if><#assign first = 0>{ aixstag: '${axes.getName()}', type: 'value', position: '${axes.getAxesPos()}'<#if axes.getCaption()??>, name: '${axes.getCaption()}'</#if><#if axes.getMaxValue()??>, max: ${axes.getMaxValue()?c}</#if><#if axes.getMinValue()??>, min: ${axes.getMinValue()?c}</#if> }
            </#if>
            </#list>
            ],
            <#elseif ctrl.getCoordinateSystem()='NONE'>, tooltip: { trigger: 'item' }<#else>, tooltip: {}</#if></#if>,
            seriesMap: { 
            <#assign first = 1>
            <#list srflist(ctrl.getPSDEChartSerieses()) as series>
            <#if first==0>, </#if><#assign first = 0>    ${series.getName()}: {type: '${series.getSeriesType()}'<#if series.getCaption()??>, caption: '${series.getCaption()}'</#if><#if series.getXPSChartAxes()??>, xaixstag: '${series.getXPSChartAxes().getName()}'</#if><#if series.getYPSChartAxes()??>, yaixstag: '${series.getYPSChartAxes().getName()}'</#if> }
            </#list>
            },
            toolbox: { show: true,  feature: { dataView: { show: true, readOnly: true, title: '数据视图' }, saveAsImage: { show: true, title: '保存为图片' }}}
        };
        return opts;
    }

    /**
     * 获取图表数据
     * 
     * @returns {*} 
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    public load(opt?:any) {
        const arg: any = { ...opt };
        this.$http.post(this.url + 'search', arg).then((res) => {
            if (res) {
                let data = JSON.parse(JSON.stringify(res.data.records[0]));
                this.$chartOption = { ...this.getChartConfig(), ...data };
                if(Object.is(this.chartType,'pie')){
                    delete this.$chartOption.xAxis;
                    delete this.$chartOption.yAxis;
                    this.$chartOption.legend.bottom  = '0';
                }
                this.drawCharts();
            }
        }).catch((error) => {
            console.error(error);
        });
    }

    /**
     * 绘制图表
     * 
     * @returns {*} 
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    public drawCharts(){
        let myChart = echarts.init(document.getElementById('myChart'));
        myChart.setOption(this.$chartOption);
    }


</#assign>

<#ibizinclude>
../@MACRO/CONTROL/CONTROL_CONTAINER.vue.ftl
</#ibizinclude>

<style lang="less">
    <#ibizinclude>
    ./CONTROL.less.ftl
    </#ibizinclude>
</style>