<template>
     <#ibizinclude>
    ./CONTROL.html.ftl
    </#ibizinclude>
</template>

<#assign self_components>
    Calendar
</#assign>

<#ibizinclude>
../@MACRO/CONTROL/CONTROL_DEFAULT.vue.ftl
</#ibizinclude>

<#assign self_header>
import { Subject } from 'rxjs';
import '@/assets/interface/viewState';
<#if ctrl.getPSControls?? && ctrl.getPSControls()??>

<#list ctrl.getPSControls() as subctrl>
<#if subctrl.getControlType() != 'TOOLBAR' && subctrl.getControlType() != 'CONTEXTMENU'>
    <#if subctrl.getPSDataEntity?? && subctrl.getPSDataEntity()??>
import view_${subctrl.getName()} from '@/widget/${srffilepath2(subctrl.getPSDataEntity().getCodeName())}/${srffilepath2(subctrl.getCodeName())}-${subctrl.getControlType()?lower_case}/${srffilepath2(subctrl.getCodeName())}-${subctrl.getControlType()?lower_case}.vue';
<#else>
import view_${subctrl.getName()} from '@/widget/app/${srffilepath2(subctrl.getCodeName())}-${subctrl.getControlType()?lower_case}/${srffilepath2(subctrl.getCodeName())}-${subctrl.getControlType()?lower_case}.vue';
</#if>
</#if>
</#list>
</#if>
import Calendar from 'vue-calendar-component';
import * as moment from 'moment';
</#assign>





<#assign self_content>
        /**
        * Api地址
        *
        * @type {string}
        * @memberof ${srfclassname('${ctrl.codeName}')}
        */
        public url: string = '${app.getPKGCodeName()?lower_case}/${de.getPSSystemModule().codeName?lower_case}/${de.codeName?lower_case}/${ctrl.codeName?lower_case}${srfclassname(ctrl.getControlType())?lower_case}/';

        /**
        * 当前年份
        *
        * @type {string}
        * @memberof ${srfclassname('${ctrl.codeName}')}
        */
        public year:number = 0;

        /**
        * 当前月份(0~11)
        *
        * @type {string}
        * @memberof ${srfclassname('${ctrl.codeName}')}
        */
        public month:number = 0;

        /**
        * 当前天
        *
        * @type {string}
        * @memberof ${srfclassname('${ctrl.codeName}')}
        */
        public day:number = 0;
        
        /**
         * 标记数组
         *
         * @type {Array<any>}
         * @memberof ${srfclassname('${ctrl.codeName}')}
         */
        public markDate:Array<any> = [];

        /**
        * 选中日期数据
        *
        * @type {any[]}
        * @memberof ${srfclassname('${ctrl.codeName}')}
        */
        public activeDateItems:Array<any> =[];

        /**
        * 初始化当前时间
        *
        * @memberof ${srfclassname('${ctrl.codeName}')}
        */
        public initcurrentTime(){
            let  tempTime=new Date();
            this.year =tempTime.getFullYear();
            this.month =tempTime.getMonth();
            this.day =tempTime.getDate();
        }

        /**
        * 日历部件数据加载
        *
        * @param any opt
        * @memberof ${srfclassname('${ctrl.codeName}')}
        */
        public load(opt: any = {}): void {
            const arg: any = {...opt};

            const parentdata: any = {};
            Object.assign(arg, parentdata);

            const post: any = this.$http.post(this.url + 'search', arg);
            post.then((response: any) => {
                if (!response) {
                    if (response.errorMessage) {
                        this.$notify({ type: 'danger', message: '错误,系统异常！' });
                    }
                    return;
                }
                const data: any = response.data;
                let tempItems:any;
                if (Object.keys(data).length > 0) {
                    tempItems = JSON.parse(JSON.stringify(data.records));
                }
                this.dataFormat(tempItems);
            }).catch((response: any) => {
                this.$notify({ type: 'danger', message: '错误,' + response.message });
            });
        }

        /**
        * 数据格式化，选择符合当天的数据
        *
        * @param {any[]} items
        * @memberof ${srfclassname('${ctrl.codeName}')}
        */
        public dataFormat(items: any[] = []): void {
            // this.$items = items;
            this.activeDateItems = [];
            items.forEach((item: any) => {
                const date: Date = (moment as any)(item.begintime).toDate();
                if (this.year === date.getFullYear() && this.month === date.getMonth() && this.day === date.getDate()) {
                    this.activeDateItems.push(item);
                }
            });
            if(this.activeDateItems.length > 0){
                let markSet = new Set(this.markDate);
                markSet.add(this.year+"-"+(this.month+1)+"-"+this.day);
                this.markDate = [...markSet];
            }
            this.dataGrounps();
        }

        /**
        * 数据分组
        *
        * @memberof ${srfclassname('${ctrl.codeName}')}
        */
        public dataGrounps(): void {
            if (this.activeDateItems.length > 0) {
                let dest = [];
                for (let i = 0; i < this.activeDateItems.length; i++) {
                    let tempObj = this.activeDateItems[i];
                    if (dest.length === 0) {
                        dest.push({ name: tempObj['type'], items: [tempObj] });
                    } else {
                        let tempFlag = true;
                        dest.forEach((ele) => {
                            if (Object.is(ele.name, tempObj['type'])) {
                                ele.items.push(tempObj);
                                tempFlag = false;
                            }
                        });
                        if (tempFlag) {
                            dest.push({ name: tempObj['type'], items: [tempObj] });
                        }
                    }
                }
                this.activeDateItems = JSON.parse(JSON.stringify(dest));
                this.$emit('valuechange',this.activeDateItems);
            }
        }

        /**
        * 日历部件数据选择日期回调
        *
        * @param any 
        * @memberof ${srfclassname('${ctrl.codeName}')}
        */
        public clickDay(data:any) {
            if (data) {
                let temptime = new Date(data);
                this.year = temptime.getFullYear();
                this.month = temptime.getMonth();
                this.day = temptime.getDate();
                let start =(moment as any)(temptime).startOf('day').format('YYYY-MM-DD HH:mm:ss');
                let end =(moment as any)(temptime).endOf('day').format('YYYY-MM-DD HH:mm:ss');
                this.load({"srfbegintime":start,"srfendtime":end});
            }
        }

        /**
        * vue生命周期created
        *
        * @memberof ${srfclassname('${ctrl.codeName}')}
        */       
        created() {
            this.handleCreated();
        }

        /**
        * 处理created之后的逻辑
        *
        * @memberof ${srfclassname('${ctrl.codeName}')}
        */    
        public handleCreated(){
            this.initcurrentTime();
			if (this.viewState) {
				this.viewState.subscribe(({ tag, action, data }) => {
					if (!Object.is(this.name, tag)) {
						return;
					}
					if (Object.is(action, "load")) {
						let  curtime=new Date()
						this.year =curtime.getFullYear();
						this.month =curtime.getMonth();
						this.day =curtime.getDate();
						let start =(moment as any)(curtime).startOf('day').format('YYYY-MM-DD HH:mm:ss');
						let end =(moment as any)(curtime).endOf('day').format('YYYY-MM-DD HH:mm:ss');
						this.load({"srfbegintime":start,"srfendtime":end}); 
					}
				});
			}
        }


</#assign>

<#ibizinclude>
../@MACRO/CONTROL/CONTROL_CONTAINER.vue.ftl
</#ibizinclude>

<style lang="less">
     <#ibizinclude>
    ./CONTROL.less.ftl
    </#ibizinclude>
</style>