<template>
    <#ibizinclude>
    ./CONTROL.html.ftl
    </#ibizinclude>
</template>

<#ibizinclude>
../@MACRO/CONTROL/CONTROL_DEFAULT.vue.ftl
</#ibizinclude>


<#assign self_content>
        /**
        * Api地址
        *
        * @type {string}
        * @memberof ${srfclassname('${ctrl.codeName}')}
        */
        <#list ctrl.getPSControls() as treeviewctrl>
         public url: string = '${app.getPKGCodeName()?lower_case}/ctrl/${treeviewctrl.codeName?lower_case}${srfclassname(treeviewctrl.getControlType())?lower_case}view/';
        </#list>

        /**
        * 节点数组
        *
        * @type Array<any>
        * @memberof IBZSAM01TreeView
        */
        public nodeArray: Array<any> = [];

        /**
         * 树视图导航当前选中项
         *
         * @memberof  ${srfclassname('${ctrl.name}')}
         */
        public selectedItem = "";

        /**
         * 树视图导航所有关联视图
         *
         * @memberof  ${srfclassname('${ctrl.name}')}
         */
        public appViewRefs = {
    <#if ctrl.getPSAppViewRefs()??>
    <#assign viewRefs = ctrl.getPSAppViewRefs()>
    <#list viewRefs  as singleView>
            '${singleView.getName()?split(":")[1]}':<#if singleView.getRefPSAppView()??>'${singleView.getRefPSAppView().getName()}'<#else>''</#if><#if singleView_has_next>,</#if>
    </#list>
    </#if>
        };

    /**
     * 树视图导航选中
     *
     * @memberof  ${srfclassname('${ctrl.name}')}
     */
    public treeexpbar_selectionchange(item:any,name:string,event:any){
          if(item){
            this.selectedItem = item;
          }
    }

    /**
     * 树视图导航数据加载成功
     *
     * @memberof  ${srfclassname('${ctrl.name}')}
     */
    public treeexpbar_load(item:any,name:string,event:any){
          console.log("树视图导航数据加载成功");
    }


    /**
     * 树节点加载
     *
     * @memberof  ${srfclassname('${ctrl.name}')}
     */

    public load(data: any) {
     const param: any = {
            srfnodeid: data && data.id ? data.id : encodeURI('#'),
            };
             this.$http.get(this.url+"getnodes",param).then((res:any) => {
                 if(res.status && res.status == 200){
                     this.nodeArray = res.data;
                     this.selectedItem = this.nodeArray[0];
                 }
             }).catch((error:any)=>{
                   this.$notify({ type: 'danger', message: '错误,' + error.data.message });
             });
<#if ctrl.getPSControls()??>
<#assign allCtrls = ctrl.getPSControls()>
<#list allCtrls as  curctrl>
      this.viewState.next({ tag: '${curctrl.name}', action: 'load', data:data })
</#list>
</#if>
    }

    /**
     * 视图数据变化事件
     *
     * @memberof  ${srfclassname('${ctrl.name}')}
     */
    public viewDatsChange(data:any){
        console.log('视图数据变化事件触发');
    }

    /**
     * vue生命周期created
     *
     * @memberof  ${srfclassname('${ctrl.name}')}
     */
    public created(){
        this.handleCreated();
    }

    /**
     * created之后的逻辑
     *
     * @memberof  ${srfclassname('${ctrl.name}')}
     */
    public handleCreated(){
        this.viewState.subscribe(({ tag, action, data }) => {
            if (!Object.is(tag, this.name)) {
                return;
            }
            if (Object.is('load', action)) {
                this.load(data);
            }
        });
    }
</#assign>

<#ibizinclude>
../@MACRO/CONTROL/CONTROL_CONTAINER.vue.ftl
</#ibizinclude>

<style lang="less">
    <#ibizinclude>
    ./CONTROL.less.ftl
    </#ibizinclude>
</style>