
<template>
     <#ibizinclude>
    ./CONTROL.html.ftl
    </#ibizinclude>
</template>

<#ibizinclude>
../@MACRO/CONTROL/CONTROL_DEFAULT.vue.ftl
</#ibizinclude>

<#assign self_header>
import { Subject } from 'rxjs';
import '@/assets/interface/viewState';
<#if ctrl.getPSControls?? && ctrl.getPSControls()??>
<#list ctrl.getPSControls() as subctrl>
<#if subctrl.getControlType() != 'TOOLBAR' && subctrl.getControlType() != 'CONTEXTMENU'>
    <#if subctrl.getPSDataEntity?? && subctrl.getPSDataEntity()??>
import view_${subctrl.getName()} from '@/widget/${srffilepath2(subctrl.getPSDataEntity().getCodeName())}/${srffilepath2(subctrl.getCodeName())}-${subctrl.getControlType()?lower_case}/${srffilepath2(subctrl.getCodeName())}-${subctrl.getControlType()?lower_case}.vue';
<#else>
import view_${subctrl.getName()} from '@/widget/app/${srffilepath2(subctrl.getCodeName())}-${subctrl.getControlType()?lower_case}/${srffilepath2(subctrl.getCodeName())}-${subctrl.getControlType()?lower_case}.vue';
</#if>
</#if>
</#list>
</#if>
<#if ctrl.getItemPSLayoutPanel()??>
<#assign layoutpanel=ctrl.getItemPSLayoutPanel()>
<#if layoutpanel.getPSDataEntity?? && layoutpanel.getPSDataEntity()??>
import view_${layoutpanel.getName()} from '@/widget/${srffilepath2(layoutpanel.getPSDataEntity().getCodeName())}/${srffilepath2(layoutpanel.getCodeName())}-${layoutpanel.getControlType()?lower_case}/${srffilepath2(layoutpanel.getCodeName())}-${layoutpanel.getControlType()?lower_case}.vue';
<#else>
import view_${layoutpanel.getName()} from '@/widget/app/${srffilepath2(layoutpanel.getCodeName())}-${layoutpanel.getControlType()?lower_case}/${srffilepath2(layoutpanel.getCodeName())}-${layoutpanel.getControlType()?lower_case}.vue';
</#if>
</#if>
</#assign>
<#assign components>
<#if ctrl.getPSControls?? && ctrl.getPSControls()??>
<#list ctrl.getPSControls() as subctrl>
<#if subctrl.getControlType() != 'TOOLBAR' &&  subctrl.getControlType() != 'CONTEXTMENU'>
  view_${subctrl.getName()}, 
</#if>
</#list>
</#if>
<#if ctrl.getItemPSLayoutPanel()??>
<#assign layoutpanel=ctrl.getItemPSLayoutPanel()>
  view_${layoutpanel.getName()} 
</#if> 
</#assign>

<#assign self_content>
    /**
    *上级传递的选中项
    *@type {Array}
    *@memberof ${srfclassname('${ctrl.codeName}')}
    */
     @Prop() public selectedData?:Array<any>;


    /**
    * 新建打开视图
    *
    * @type {Function}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    @Prop() public newdata?: Function; 


    /**
    * 打开视图
    *
    * @type {Function}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    @Prop() public opendata?: Function; 

    /**
    * 关闭行为
    *
    * @type {Function}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    
    @Prop() public close?:Function;

    /**
    * Api地址
    *
    * @type {string}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    <#if view.getViewType()?? && view.getViewType()=='DEMOBWFMDVIEW'>
    public url: string = '${app.getPKGCodeName()?lower_case}/ibizutil/worklist/maingrid/searchmy';
    <#else>
    public url: string = '${app.getPKGCodeName()?lower_case}/${de.getPSSystemModule().codeName?lower_case}/${de.codeName?lower_case}/${ctrl.codeName?lower_case}${srfclassname(ctrl.getControlType())?lower_case}/';
    </#if>

    <#if view.getViewType()?? && view.getViewType()=='DEMOBPICKUPMDVIEW'>
    /**
    * 存放多数据选择数组（多选）
    *
    * @type {array}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public checkboxList:Array<string> = [];

    /**
    * 存放数据选择数组(单选)
    *
    * @type {object}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public radio:any = '';

    /**
    * 点击多选按钮触发
    *
    *
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public change(){
        if(this.isMutli){
             let checkboxLists= this.items.filter((item,index)=>{
                  if(this.checkboxList.indexOf(item.srfkey)!=-1){
                    return true;
                  }else{
                    return false;
                  }
                })
          this.$emit('selectchange',checkboxLists);
        }else{
           let radioItem = this.items.filter((item,index)=>{return item.srfkey==this.radio});
           this.$emit('selectchange',radioItem);
        }
    }
    </#if>

    /**
    * 列表键值对
    *
    * @type {Map}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public listMap:any = new Map();

    /**
    * 分页大小
    *
    * @type {number}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public pageSize:number = ${ctrl.getPagingSize()?c};

    /**
    * 总页数
    *
    * @type {number}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
     public pageTotal:number = 0;

    /**
    * 当前页数
    *
    * @type {number}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
     public pageNumber:any = 1;

    /**
    * 判断底部数据是否全部加载完成，若为真，则 bottomMethod 不会被再次触发
    *
    * @type {number}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
     public allLoaded: boolean = false;

    /**
    * 底部状态
    *
    * @type {String}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public bottomStatus: String = "";

    /**
    * 顶部状态
    *
    * @type {String}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public topStatus: String = "";

    /**
    * 
    *
    * @type {Number}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public moveTranslate: Number = 0;

    /**
    * searchKey 搜索关键字
    *
    * @type {string}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
     public searchKey:string = '';

    /**
    * 列表数组
    *
    * @param {Array<any>}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public items:Array<any> =[];

    /**
    * 选中数组
    *
    * @param {Array<any>}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public selectedArray:Array<any> = [];

    /**
    * 多选计数
    *
    * @param {number}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public selectednumber:number =0;

    /**
    * 搜索行为
    *
    * @param {string}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    @Prop() public searchAction?:string;

    /**
    * 是否为选择视图
    *
    * @param {boolean} 
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    @Prop() public isSelected?:boolean;

    /**
    * 是否多选
    *
    * @type {boolean}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    @Prop({default:false}) public isMutli?: boolean;

    /**
    * 单选选择值
    *
    * @param {string} 
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public selectedValue:string = ""; 
    
    /**
    * 底部改变状态
    * 
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public handleBottomChange(status: String) {
      this.bottomStatus = status;
    }

    /**
    * 顶部改变状态
    * 
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public handleTopChange(status: String) {
      this.moveTranslate = 1;
      this.topStatus = status;
    }

    /**
    * 上拉加载更多数据
    * 
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public loadBottom() {
      this.pageNumber++;
      this.load(Object.assign({query:this.searchKey},{page: { current: this.pageNumber, size: this.pageSize }}),'bottom');
    }

    /**
     * 多项数据删除行数据
     *
     * @private
     * @param {*} [arg={}]
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    private remove(opt: any = {}):Promise<any>{
        return new Promise((resolve, reject) =>{
            const arg: any = { ...opt };
            const parentdata: any = {};
            Object.assign(arg, parentdata);
            const post: any = this.$http.post(this.url + 'remove', {srfkeys:arg.srfkey});
            post.then((response:any) =>{
                if(response){
                    this.$notify({ type: 'success', message: '删除成功'});
                    this.load();
                    resolve(response);
                }
            }).catch((error: any) => {
                this.$notify({ type: 'danger', message: '错误,' + error });
                reject(error);
            });
        })
    }

    /**
     * 刷新数据
     *
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    public refresh():void{
        this.load()
    }

    /**
    * 多项数据加载
    *
    * @private
    * @param {*} [arg={}]
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    private load(data:any={},type:any=""):void {
    <#if view.getViewType()?? && view.getViewType()=='DEMOBWFMDVIEW'>
            const post: Promise<any> = this.$http.post(this.url, data);
    <#else>
            const post: Promise<any> = this.$http.post(this.url + this.searchAction, data);
    </#if>
            post.then((response: any) => {
            if (!response || response.status !== 200) {
              this.$notify({ type: 'danger', message: '错误,' + response.info });
            }
            this.$emit('load',response.data);
            this.pageTotal = response.data.total;
            this.allLoaded = this.pageNumber>=this.pageTotal/this.pageSize?true:false;
           if(type=='top'){
                this.items=[];
                this.items = response.data.records;
                let  loadmore:any = this.$refs.loadmore;
                loadmore.onTopLoaded();
            }
          else if(type=='bottom'){
                setTimeout(()=>{
                      for(let i=0;i<response.data.records.length;i++){
                      this.items.push(response.data.records[i]);
                  }
                    let  loadmore:any = this.$refs.loadmore;
                    loadmore.onBottomLoaded();
                  },2000)
            }else{
              this.items=[];
              this.items = response.data.records;
            }
          })
          .catch((response: any) => {
            if (response && response.status === 401) {
              return;
            }
            if (!response || !response.status || !response.data) {
              this.$notify({ type: 'danger', message: '错误,系统异常！' });
              return;
            }
            const { data: _data } = response;
            console.error(_data.title + _data.message);
          });
    }

    /**
    * 全选
    *
    * @private
    * @param {*} [arg={}]
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    private handleClick() {
        this.items.forEach((item: any) => {
            item.value = true;
        });
        this.selectednumber = this.items.length;
    }

    /**
    * checkbox 选中回调
    *
    * @private
    * @param {*} [arg={}]
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public checkboxChange(data:any){
        this.selectednumber =0;
        this.items.forEach((item: any) => {
            if(item.value){
                this.selectednumber ++;
            }
        });
    }
 
    /**
    * 下拉刷新
    *
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public loadTop() {
      this.pageNumber=1;
      this.load(Object.assign({query:this.searchKey},{page: { current: this.pageNumber, size: this.pageSize }}),'top');
    }

    /**
    * 点击列表数据跳转
    *
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public goPage(item: String) {
      this.selectedArray.push(item);
      this.$emit('click',item);
    }

    /**
    * 获取多项数据
    *
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public getDatas(): any[] {
      return this.selectedArray;
    }

    /**
    * 获取单项数据
    *
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public getData(): any {
        return this.selectedArray[0];
    }

    /**
    * vue生命周期created
    *
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public created() {
      this.handleCreated();
    }

    /**
    * created后的执行逻辑
    *
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public handleCreated(){
      if (this.viewState) {
        this.viewState.subscribe(({ tag, action, data }) => {
          if (!Object.is(this.name, tag)) {
            return;
          }
          if (Object.is(action, "load")) {
            this.pageNumber = 1;
            this.load(Object.assign(data, {page: { current: this.pageNumber, size: this.pageSize }}),"init");
          }
          if (Object.is(action, "search")) {
            this.load(Object.assign(data, {page: { current: this.pageNumber, size: this.pageSize }}),"init" );
          }
          if (Object.is(action, "quicksearch")) {
            this.searchKey = data;
            this.load( Object.assign( { query: data }, { page: { current: 1, size: this.pageSize*this.pageNumber }}),"init");
          }
          if (Object.is(action, "refresh")) {
            this.refresh();
          }
        });
      }
      this.initMap();
      <#if view.getViewType()?? && view.getViewType()=='DEMOBPICKUPMDVIEW'>
      if(!this.isMutli){
        if(this.selectedData){
            this.radio = this.selectedData[0].srfkey;
        }
      }else{
            if(this.selectedData){
              this.checkboxList =[];
              this.selectedData.forEach((item:any)=>{
                  this.checkboxList.push(item.srfkey);
              })
            }
          }
        </#if>
    }

    /**
    * 初始化Map
    *
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public initMap(){
      <#if ctrl.getPSDEListItems?? && ctrl.getPSDEListItems()??>
          <#list ctrl.getPSDEListItems() as lists>
              this.listMap.set('${lists.getName()}','${lists.getCaption()}');
          </#list>
        </#if>
    }

    /**
     * 列表项左滑右滑触发行为
     * 
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    public mdctrl_click(tag:any,item:any){
        this.selectedArray = [];
        this.selectedArray.push(item);
<#if ctrl.getPSDEUIActionGroup()?? && ctrl.getPSDEUIActionGroup().getPSUIActionGroupDetails()??>
<#assign details = ctrl.getPSDEUIActionGroup().getPSUIActionGroupDetails()>
<#list details as detail>
        if(Object.is(tag,'${detail.getName()}')){
            this.mdctrl_${detail.getName()}_click();
        }
</#list>
</#if>
<#if ctrl.getPSDEUIActionGroup2()?? && ctrl.getPSDEUIActionGroup2().getPSUIActionGroupDetails()??>
<#assign details = ctrl.getPSDEUIActionGroup2().getPSUIActionGroupDetails()>
<#list details as detail>
        if(Object.is(tag,'${detail.getName()}')){
            this.mdctrl_${detail.getName()}_click();
        }
</#list>
</#if>   
    }

</#assign>

<#ibizinclude>
../@MACRO/CONTROL/CONTROL_CONTAINER.vue.ftl
</#ibizinclude>

<style lang="less">
     <#ibizinclude>
    ./CONTROL.less.ftl
    </#ibizinclude>
</style>