<template>
    <div>
    <#ibizinclude>
    ./CONTROL.html.ftl
    </#ibizinclude>
    </div>
</template>

<#ibizinclude>
../@MACRO/CONTROL/CONTROL_DEFAULT.vue.ftl
</#ibizinclude>
<#assign self_header>
import { FormButtonModel, FormPageModel, FormItemModel, FromDRUIPartModel, FormPartModel, FormGroupPanelModel, FormRowItemModel, FormTabPageModel, FormTabPanelModel, FormUserControlModel } from '@/assets/form-detail';
import { Subject } from 'rxjs';
</#assign>
<#assign self_content>

   /**
    * 加载行为
    *
    * @type {string}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    @Prop() public loadAction?:string;

    /**
    * 加载草稿行为
    *
    * @type {string}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    @Prop() public loaddraftAction?:string;

    /**
    * 更新行为
    *
    * @type {string}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    @Prop() public updateAction?:string;

    /**
    * 创建行为
    *
    * @type {string}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    @Prop() public createAction?:string;

    /**
    * 关闭行为
    *
    * @type {Function}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    @Prop() public close?:Function;

    /**
    * 删除行为
    *
    * @type {string}
    * @memberof ${srfclassname('${ctrl.name}')}
    */
    @Prop() public removeAction?:string;

    /**
    * 加载表单草稿行为
    *
    * @type {string}
    * @memberof ${srfclassname('${ctrl.name}')}
    */
    @Prop() public loaddraftformAction?:string;

    /**
    * 工作流程开始行为
    *
    * @type {string}
    * @memberof ${srfclassname('${ctrl.name}')}
    */
    @Prop() public wfstartAction?:string;

    /**
    * 工作流程提交行为
    *
    * @type {string}
    * @memberof ${srfclassname('${ctrl.name}')}
    */    
    @Prop() public wfsubmitAction?:string;

    /**
        * 表单状态
        *
        * @type {Subject<any>}
        * @memberof ${srfclassname('${ctrl.name}')}
        */
    public formState: Subject<any> = new Subject();

    /**
    * Api地址
    *
    * @type {string}
    * @memberof ${srfclassname('${ctrl.name}')}
    */
    public url: string = '${app.getPKGCodeName()?lower_case}/${de.getPSSystemModule().codeName?lower_case}/${de.codeName?lower_case}/${ctrl.codeName?lower_case}${srfclassname(ctrl.getControlType())?lower_case}/';
    
    /**
    * 当前执行的行为逻辑
    *
    * @type {string}
    * @memberof ${srfclassname('${ctrl.name}')}
    */
    public currentAction: string = "";
    
    /**
    * 详情模型集合
    *
    * @type {*}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public detailsModel: any = {};

    /**
     * 忽略表单项值变化
     *
     * @type {boolean}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public ignorefieldvaluechange: boolean = false;

    /**
    * 表单数据对象
    *
    * @type {*}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public data: any = {
        <#list ctrl.getPSDEFormItems() as item>
        ${item.getName()}: null,
        </#list>
        ismodify:false
    };


    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public getDatas(): any[] {
        return [this.data];
    }

    /**
     * 获取单项数据
     *
     * @returns {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public getData(): any {
        return this.data;
    }

<#if ctrl.getAllPSDEFormDetails()??>
<#list ctrl.getAllPSDEFormDetails() as detail>
<#if detail.getDetailType() == "GROUPPANEL">

    /**
    * 是否展示表单分组${detail.getCaption()}内容
    *
    * @type {boolean}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public isDisplayContent_${detail.name}: boolean = true;
</#if>
</#list>
</#if>

    /**
    * 控制展示表单分组
    *
    * @type { Array<any>}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public activeNames: Array<any> = [<#if ctrl.getAllPSDEFormDetails()??><#list ctrl.getAllPSDEFormDetails() as detail><#if detail.getDetailType() == "GROUPPANEL">'${detail.name}',</#if></#list></#if>];

    /**
    * 初始化表单详情模型集合
    *
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public initFormDetailsModel(): void {
        <#list ctrl.getAllPSDEFormDetails() as formdetail>
        Object.assign(this.detailsModel, {
            ${formdetail.name}: ${P.getPartCode(formdetail, 'DETAIL_MODEL').code}
        });
        </#list>
    }

    /**
    * 属性值规则
    *
    * @type {*}
    * @memberof ${srfclassname('${ctrl.name}')}
    */
    public rules: any = {
        <#list ctrl.getAllPSDEFormDetails() as formdetail>
        <#if formdetail.getDetailType?? && formdetail.getDetailType() == 'FORMITEM'>
        ${formdetail.getName()}: [
            { required: <#if formdetail.isAllowEmpty()>false<#else>true</#if>, type: '<#assign datatype=srfjavatype(formdetail.getStdDataType())><#if datatype=='BigInteger' || datatype=='Integer' || datatype=='Double'>number<#else>string</#if>', message: '${formdetail.getCaption()}值不能为空!', trigger: 'change' }
        ],
        </#if>
        </#list>
    }

     /**
     * 表单逻辑
     *
     * @private
     * @param {{ name: string, newVal: any, oldVal: any }} { name, newVal, oldVal }
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    private formLogic({ name, newVal, oldVal }: { name: string, newVal: any, oldVal: any }): void {
        <#if P.getPartCode(item,'FORM_LOGIC').code?length gt 0>
        ${P.getPartCode(item,'FORM_LOGIC').code}
        </#if>
        <#if ctrl.getPSDEFormItems()??>
        <#list ctrl.getPSDEFormItems() as formitem>
        <#if formitem.getPSDEFormItemUpdate()??>
        if(Object.is(name, '${formitem.name}')){
            this.updateFormItems('${formitem.getPSDEFormItemUpdate().codeName}', this.data,false);
        }
        </#if>
        </#list>
        </#if>
    }

    /**
    * 检验规则
    *
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public validateRules():boolean{
        let result =true;
        Object.keys(this.rules).forEach((item:any) =>{
            //必填校验
            if(this.rules[item][0].required){
                if(!this.data[item]){
                    this.$notify({ type: 'danger', message: this.rules[item][0].message});
                    result = false;
                    return result;
                }
            }
        });
        return result;
    }

    /**
    * 值填充
    *
    * @param {*} [_datas={}]
    * @memberof  ${srfclassname('${ctrl.codeName}')}
    */
    public fillForm(_datas: any = {}): void {
        this.ignorefieldvaluechange = true;
        Object.keys(_datas).forEach((name: string) => {
            if (this.data.hasOwnProperty(name)) {
                this.data[name] = _datas[name];
            }
        });
        this.$nextTick(function () {
            this.ignorefieldvaluechange = false;
        })
    }

    /**
    * 当前分页
    *
    * @type {string}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
<#if ctrl.getPSDEFormPages()??>
<#list ctrl.getPSDEFormPages() as formPage>
<#if formPage_index = 0>
    public activeFormPage:string = '${formPage.name}';
</#if>
</#list>
</#if>
<#if ctrl.getPSDEFormPages()??>

    /**
    * 分页信息
    *
    * @type {[]}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
public tabList = [
<#list ctrl.getPSDEFormPages() as formPage>
    { tabTitle: "${formPage.caption}", value: "${formPage.name}"<#if formPage_index = 0>,'curr':true</#if>}<#if formPage_has_next>,</#if>
</#list>
];
</#if>

    /**
    * 表单分页变化
    *
    * @param {name:标签标识符,title:标题}
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public tabSwitch(name:any, title:any) {
        this.activeFormPage = name;
    }

    /**
    * vue生命周期
    *
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public created(){
        this.handleCreated();
    }

    /**
    * 执行created后面的逻辑
    *
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public handleCreated(){
        this.initFormDetailsModel();
        this.viewState.subscribe(( {tag,action,data })=>{
            if (!Object.is(tag, this.name)) {
                return;
            }
            if (Object.is('autoload', action)) {
                this.autoLoad(data);
            }
            if (Object.is('load', action)) {
                this.load(data);
            }
            if (Object.is('loaddraft', action)) {
                this.loadDraft(data);
            }
            if (Object.is('save', action)) {
                this.save(data);
            }
            if (Object.is('remove', action)) {
                this.remove(data);
            }
            if (Object.is('saveandexit', action)) {
                this.saveAndExit(data);
            }
            if (Object.is('saveandnew', action)) {
                this.saveAndNew(data);
            }
            if (Object.is('removeandexit', action)) {
                this.removeAndExit(data);
            }
            if (Object.is('refresh', action)) {
                this.refresh(data);
            }
            if (Object.is('submit', action)) {
                this.submitWorkFlow(data,'wfsubmit');
            }
                if(Object.is('saveandstart',action)){
                    this.saveAndStart(data);
                }
        })
    }

    /**
    * 自动加载
    *
    * @param {*} [arg={}]
    * @returns {void}
    * @memberof ${srfclassname('${ctrl.name}')}
    */
    public autoLoad(arg: any = {}): void {
        if (arg.srfkey && !Object.is(arg.srfkey, '')) {
            this.load(arg);
            return;
        }
        if (arg.srfkeys && !Object.is(arg.srfkeys, '')) {
            Object.assign(arg, { srfkey: arg.srfkeys });
            this.load(arg);
            return;
        }
        this.loadDraft(arg);
    }

    /**
    * 加载
    *
    * @private
    * @param {*} [opt={}]
    * @memberof ${srfclassname('${ctrl.name}')}
    */
    private load(opt: any = {}): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
            const arg: any = { ...opt };
            this.$http.get(this.url + this.loadAction, {srfkey:arg.srfkey}).then((response: any) => {
                if (response) {
                    const data = response.data;
                    this.$emit('load',data);
                    this.formState.next({ type: 'load', data: data });
                    this.fillForm(data);
                    this.formLogic({ name: '', newVal: null, oldVal: null });
                    this.data.ismodify = false;
                    resolve(data);
                }
            }).catch((error: any) => {
                this.$notify({ type: 'danger', message: '错误,' + error.data.message });
                reject(error);
            });
        })
    }

    /**
    * 删除
    *
    * @private
    * @param {*} [opt={}]
    * @memberof ${srfclassname('${ctrl.name}')}
    */
    private remove(opt: any = {}): Promise<any> {
        if(!Object.is(opt.srfkey,this.data.srfkey)){
            return Promise.resolve(null);
        }
        return new Promise((resolve: any, reject: any) => {
            const arg: any = { ...opt };
            this.$http.get(this.url + this.removeAction, {srfkey:arg.srfkey}).then((response: any) => {
                if (response) {
                    const data = response.data;
                    this.$emit('remove',data);
                    this.formState.next({ type: 'remove', data: data });
                    this.data.ismodify = false;
                    this.$notify({ type: 'success', message: '成功,删除数据成功！'});
                    resolve(data);
                }
            }).catch((error: any) => {
                this.$notify({ type: 'danger', message: '错误,' + error.data.message });
                reject(error);
            });
        });
    }

    /**
     * 开始工作流
     *
     * @param {} data
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    public startWorkFlow(data: any = {}): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
            const arg: any = { ...data };
            this.$http.post(this.url + this.wfstartAction, arg).then((response: any) => {
                if (!response) {
                    this.$notify({ type: 'danger', message: '开始流程失败'});
                }
                if (response) {
                    resolve(response);
                    this.$notify({ type: 'success', message: '开始流程成功'});
                    if (this.close && this.close instanceof Function) {
                       this.close(arg);
                    }
                }
            }).catch((error:any) =>{
                 this.$notify({ type: 'danger', message: error.data.message});
            });
        });
    }

    /**
     * 提交工作流
     *
     * @param {} data
     * @memberof ${srfclassname('${ctrl.name}')}
     */
    public submitWorkFlow(data: any = {},actionUrl?:string): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
            const arg: any = { ...data };
            Object.assign(arg,{srfkey:this.$data.srfkey});
            let rquestUrl = actionUrl?this.url+actionUrl:this.url+this.wfsubmitAction;
            this.$http.post(rquestUrl, arg).then((response: any) => {
                if (!response) {
                    reject({});
                }
                if (response) {
                    this.$emit('wfsubmit',response);
                    resolve(response);
                }
            });
        });
    }

        /**
         * 保存并开始工作流
         * @param {} data
         * @memberof ${srfclassname('${ctrl.name}')}
         */
        public saveAndStart(data:any ={}):Promise<any>{
             let _this = this;
            return new Promise((resolve: any, reject: any) =>{
                let arg: any = {};
                Object.assign(arg,data);
                _this.currentAction = "saveAndStart";
                _this.save(arg).then((res) =>{
                    if(_this.startWorkFlow){
                        _this.startWorkFlow(res);
                    }
                    resolve(res);
                }).catch((error) =>{
                    reject(error);
                })
            })
        }

    /**
    * 加载草稿
    *
    * @param {*} [opt={}]
    * @memberof ${srfclassname('${ctrl.name}')}
    */
    public loadDraft(opt: any = {}): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
            const arg: any = { ...opt };
            let post: any;
            if (!arg.srfsourcekey || Object.is(arg.srfsourcekey, '')) {
                post = this.$http.post(this.url + this.loaddraftAction, arg);
            } else {
                post = this.$http.post(this.url + this.loaddraftformAction, arg);
            }
            post.then((response: any) => {
                if (response) {
                    const data = response.data;
                    this.$emit('load',data);
                    this.formState.next({ type: 'load', data: data });
                    this.fillForm(data);
                    this.formLogic({ name: '', newVal: null, oldVal: null });
                    this.data.ismodify = false;
                    resolve(data);
                }
            }).catch((error: any) => {
                this.$notify({ type: 'danger', message: '错误,' + error.data.message });
                reject(error);
            });
        })
    }

    /**
    * 自动保存
    *
    * @param {*} [opt={}]
    * @memberof ${srfclassname('${ctrl.name}')}
    */
    public autoSave(opt: any = {}, action?: string): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
            let result = this.validateRules();
            if(!result){
                return;
            }
            const arg: any = { ...opt };
            const data = this.getData();
            Object.assign(arg, data);
            if (!action) {
                this.formState.next({ type: 'beforesave', data: arg });//editview9保存之前事件
            }
            if (arg.end) {
                return;
            }
            let post: any;
            if (Object.is(data.srfuf, '1')) {
                post = this.$http.post(this.url + this.updateAction, arg);
            } else {
                post = this.$http.post(this.url + this.createAction, arg);
            }
            post.then((response: any) => {
                if (response) {
                    const data = response.data;
                    this.$emit('save',data);
                    this.formState.next({ type: 'save', data: data });
                    this.fillForm(data);
                    this.formLogic({ name: '', newVal: null, oldVal: null });
                    this.data.ismodify = false;
                    this.$notify({ type: 'success', message: '成功,保存数据成功！'});
                    resolve(data);
                }
            }).catch((error: any) => {
                this.$notify({ type: 'danger', message: '错误,' + error.data.message });
                reject(error);
            });
        })
    }

    /**
    * 保存
    *
    * @param {*} [opt={}]
    * @memberof ${srfclassname('${ctrl.name}')}
    */

    public save(opt: any = {},action?: string): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
            let result = this.validateRules();
            if(!result){
                return;
            }
            const arg: any = { ...opt };
            const data = this.getData();
            Object.assign(arg, data);
            if (!action) {
            this.formState.next({ type: 'beforesave', data: arg });//editview9保存之前事件
            }
            if (arg.end) {
                return;
            }
            let post: any;
            if (Object.is(data.srfuf, '1')) {
                post = this.$http.post(this.url + this.updateAction, arg);
            } else {
                post = this.$http.post(this.url + this.createAction, arg);
            }
            post.then((response: any) => {
                if (response) {
                    const data = response.data;
                    this.$emit('save',data);
                    this.formState.next({ type: 'save', data: data });
                    this.fillForm(data);
                    this.formLogic({ name: '', newVal: null, oldVal: null });
                    this.data.ismodify = false;
                    if(action){
                        this.$notify({ type: 'success', message: (data.srfmajortext ? data.srfmajortext : '') + '保存成功！' });
                    }
                    resolve(data);
                }
            }).catch((error: any) => {
                if(!arg.iscancelnotice){
                    this.$notify({ type: 'danger', message: '错误,' + error.data.message });
                    reject(error);
                }
            })
        })
    }

    /**
    * 表单项更新
    *
    * @param {string} mode
    * @memberof ${srfclassname('${ctrl.name}')}
    */
    public updateFormItems(mode: string, data: any = {}, showloading?: boolean): void {
        if (!mode || (mode && Object.is(mode, ''))) {
            return;
        }
        const action = mode.toLowerCase();
        const arg: any = { ...data };
        this.$http.post(this.url + 'updateformitem/' + action, arg,showloading).then((response: any) => {
            if (!response) {
                this.$notify({ type: 'danger', message: '失败,加载数据失败' });
            }
            if (response) {
                const data = response.data;
                this.formState.next({ type: 'updateformitem', ufimode: arg.srfufimode, data: data });
                this.fillForm(data);
                this.formLogic({ name: '', newVal: null, oldVal: null });
            }
        });
    }

    /**
    * 部件刷新
    *
    * @param {any[]} args
    * @memberof ${srfclassname('${ctrl.name}')}
    */
    public refresh(args: any[]): Promise<any> {
        return new Promise((resolve: any, reject: any) =>{
        let arg: any = {};
        if (this.data.srfkey && !Object.is(this.data.srfkey, '')) {
            Object.assign(arg, { srfkey: this.data.srfkey });
            this.load(arg);
            return;
        }
        if (this.data.srfkeys && !Object.is(this.data.srfkeys, '')) {
            Object.assign(arg, { srfkey: this.data.srfkeys });
            this.load(arg);
            return;
        }
        })
    }

    /**
    * 保存并退出
    *
    * @param {any[]} args
    * @memberof ${srfclassname('${ctrl.name}')}
    */
    public saveAndExit(data:any):Promise<any>{
        let _this = this;
        return new Promise((resolve: any, reject: any) =>{
            let arg: any = {};
            Object.assign(arg,data);
            _this.currentAction = "saveAndExit";
            _this.save(arg).then((res) =>{
                if(res){
                    if(_this.close){
                        _this.close(res.data);
                    }
                }
                resolve(res);
            }).catch((error) =>{
                reject(error);
            })
        })
    }

    /**
    * 保存并新建
    *
    * @param {any[]} args
    * @memberof ${srfclassname('${ctrl.name}')}
    */
    public saveAndNew(data:any):Promise<any>{
        let _this = this;
        return new Promise((resolve: any, reject: any) =>{
            let arg: any = {};
            Object.assign(arg,data);
            _this.currentAction = "saveAndNew";
            _this.save(arg).then((res) =>{
                _this.ResetData(res);
                _this.loadDraft({});
                resolve(res);
            }).catch((error) =>{
                reject(error);
            })
        })
    }

    /**
    * 删除并退出
    *
    * @param {any[]} args
    * @memberof ${srfclassname('${ctrl.name}')}
    */
    public removeAndExit(data:any):Promise<any>{
        let _this = this;
        return new Promise((resolve: any, reject: any) =>{
            let arg: any = {};
            Object.assign(arg,data);
            _this.remove(arg).then((res) =>{
                if(res){
                    if(_this.close){
                        _this.close(res.data);
                    }
                }
                resolve(res);
            }).catch((error) =>{
                reject(error);
            })
        })
    }

    /**
    * 置空对象
    *
    * @param {any[]} args
    * @memberof ${srfclassname('${ctrl.name}')}
    */
    public ResetData(_datas:any){
        if(Object.keys(_datas).length >0){
            Object.keys(_datas).forEach((name: string) => {
            if (this.data.hasOwnProperty(name)) {
                this.data[name] = null;
            }
        });
        }
    }

    /**
    * 切换样式
    *
    * @param {*} [opt={}]
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public toggleDisplay(groupname:string) {
<#if ctrl.getAllPSDEFormDetails()??>
<#list ctrl.getAllPSDEFormDetails() as detail>
<#if detail.getDetailType() == "GROUPPANEL">
        if(Object.is('${detail.name}',groupname)){
        this.isDisplayContent_${detail.name} = !this.isDisplayContent_${detail.name};
        }
</#if>
</#list>
</#if>
    }

    /**
    * 表单项值改变
    *
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public valueChange(name:string,value:any){
        if (this.ignorefieldvaluechange) {
            return;
        }
        let oldValue = JSON.parse(JSON.stringify(this.data[name]));
        this.data[name] = value;
        this.formLogic({name:name,newVal:this.data[name],oldVal:oldValue});
        this.data.ismodify = true;
        this.$forceUpdate();
    }

    /**
    * DEMEDITVIEW9 关系数据保存完成
    *
    * @param {any} $event
    * @memberof ${srfclassname('${ctrl.codeName}')}
    */
    public drdatasaved($event:any){
        let _this = this;
        this.save({},$event.action).then((res) =>{
            if(Object.is(_this.currentAction, "saveAndNew")){
                _this.ResetData(res);
                _this.loadDraft({});
            }else if(Object.is(_this.currentAction, "saveAndExit")){
                if(res){
                    if(_this.close){
                        _this.close(res);
                    }
                }
            }else if(Object.is(_this.currentAction, "saveAndStart")){
                if(_this.startWorkFlow){
                    _this.startWorkFlow(res);
                }
            }
        });
    }

</#assign>

<#ibizinclude>
../@MACRO/CONTROL/CONTROL_CONTAINER.vue.ftl
</#ibizinclude>

<style lang="less">
    <#ibizinclude>
    ./CONTROL.less.ftl
    </#ibizinclude>
</style>